TypeScript SDK
import { Client } from "@notionhq/client"
const notion = new Client({ auth: process.env.NOTION_API_KEY })
const response = await notion.sessions.queryEvents({
session_id: "2a1c7c06-781b-4987-9986-5c8dd3028014",
filter: { property: "type", event_type: { equals: "agent.message" } }
})curl --request POST \
--url https://api.notion.com/v1/sessions/{session_id}/events/query \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Notion-Version: <notion-version>' \
--data '
{
"filter": {
"property": "id",
"string": {
"equals": "<string>"
}
},
"sorts": [
{}
],
"start_cursor": "<string>",
"page_size": 50
}
'import requests
url = "https://api.notion.com/v1/sessions/{session_id}/events/query"
payload = {
"filter": {
"property": "id",
"string": { "equals": "<string>" }
},
"sorts": [{}],
"start_cursor": "<string>",
"page_size": 50
}
headers = {
"Notion-Version": "<notion-version>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
{
"object": "list",
"type": "session_event",
"session_event": {},
"results": [
{
"object": "session_event",
"id": "<string>",
"session_id": "<string>",
"sequence": 2,
"created_at": "<string>",
"type": "user.message",
"content": [
{
"type": "text",
"text": "<string>"
}
],
"created_by": {
"id": "<string>"
},
"metadata": {}
}
],
"has_more": true,
"next_cursor": "<string>"
}{
"object": "error",
"message": "<string>",
"status": 400,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "unauthorized",
"status": 401,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"status": 403,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"status": 404,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "row_limit_exceeded",
"status": 406,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"status": 409,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "rate_limited",
"status": 429,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "internal_server_error",
"status": 500,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "service_unavailable",
"status": 503,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "gateway_timeout",
"status": 504,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "service_overload",
"status": 529,
"additional_data": {}
}Agents
Query session events
Retrieve a page of events from an accessible session.
POST
/
v1
/
sessions
/
{session_id}
/
events
/
query
TypeScript SDK
import { Client } from "@notionhq/client"
const notion = new Client({ auth: process.env.NOTION_API_KEY })
const response = await notion.sessions.queryEvents({
session_id: "2a1c7c06-781b-4987-9986-5c8dd3028014",
filter: { property: "type", event_type: { equals: "agent.message" } }
})Tool calls identify their tool and lifecycle status, without tool inputs or outputs.
Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Headers
The API version to use for this request. The latest version is 2026-03-11.
Available options:
2026-03-11 Path Parameters
The ID of the session whose events should be queried.
Body
application/json
A session event property filter, or an and/or compound filter nested up to three levels deep.
- Option 1
- Option 2
- Option 3
- Option 4
- Option 5
- Option 6
Show child attributes
Show child attributes
Ordered sort precedence. Defaults to sequence ascending.
Required array length:
1 - 2 elementsShow child attributes
Show child attributes
The continuation cursor returned by the previous page.
The number of events to return. Maximum: 100.
Required range:
1 <= x <= 100Response
Always list
Allowed value:
"list"Always session_event
Allowed value:
"session_event"Maximum array length:
100- Option 1
- Option 2
- Option 3
- Option 4
- Option 5
- Option 6
Show child attributes
Show child attributes
⌘I